/* Sistemas Integrados TEKNISA

Nome: 400G_ESTTRGO_ATUALIZA_INSERT_LOTE.SQL

Descrio:
Trigger para inserir ordenao do Lote.

Criao
13/07/2006 - Fabrcio Marcelo

@C:\WEB_509\SQL\END_CONV\ORACLE\400G_ESTTRGO_ATUALIZA_INSERT_LOTE.SQL
*/

CREATE OR REPLACE TRIGGER ATUALIZA_INSERT_LOTE
BEFORE UPDATE OR INSERT ON LOTE FOR EACH ROW
DECLARE
   V_CDPRODEXT   VARCHAR2(20);   /* Codigo do produto externo */
   V_STORDELOTE  VARCHAR2(50);   /* Ordenao do Lote */
   V_STNUMELOTE  VARCHAR2(50);   /* Numero do Lote */
   V_SEQLOTE     VARCHAR2(20);   /* Sequencial do Lote */
   V_INAJUSTA    NUMBER;         /* Valor do complemento da variavel seq */
   V_DATA        DATE;
BEGIN

   V_DATA := NVL(:NEW.DTENTRLOTE,SYSDATE);

   BEGIN
      SELECT
         CDPRODINTE
      INTO
         V_CDPRODEXT
      FROM
         PRODUTO
      WHERE
         (CDPRODUTO = :NEW.CDPRODUTO);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN BEGIN
         V_CDPRODEXT := NULL;
      END;
   END;

   BEGIN
      SELECT
         DSORDENALOTE,
         DSNUMELOTE
      INTO
         V_STORDELOTE,
         V_STNUMELOTE
      FROM
         PARAMFILIAL
      WHERE
         CDFILIAL = :NEW.CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN BEGIN
         V_STORDELOTE := NULL;
         V_STNUMELOTE := NULL;
      END;
   END;


   V_STNUMELOTE := REPLACE(V_STNUMELOTE, '[ANO]'  , TO_CHAR(V_DATA, 'YYYY'));
   V_STNUMELOTE := REPLACE(V_STNUMELOTE, '[ANO2]' , TO_CHAR(V_DATA, 'YY'));
   V_STNUMELOTE := REPLACE(V_STNUMELOTE, '[ANO4]' , TO_CHAR(V_DATA, 'YYYY'));

   V_STNUMELOTE := REPLACE(V_STNUMELOTE, '[MES]'  , TO_CHAR(V_DATA, 'MM'));
   V_STNUMELOTE := REPLACE(V_STNUMELOTE, '[DIA]'  , TO_CHAR(V_DATA, 'DD'));
   V_STNUMELOTE := REPLACE(V_STNUMELOTE, '[FIL]'  , :NEW.CDFILIAL);
   V_STNUMELOTE := REPLACE(V_STNUMELOTE, '[CDEXT]', V_CDPRODEXT);

   IF INSTR(V_STNUMELOTE,'[SEQ]') > 0 THEN
      V_SEQLOTE := SUBSTR(:NEW.NRLOTEESTQ, INSTR(V_STNUMELOTE,'[SEQ]'), 10);
   ELSIF INSTR(V_STNUMELOTE,'[SEQ') > 0 THEN
      V_INAJUSTA := TO_NUMBER(SUBSTR(V_STNUMELOTE, INSTR(V_STNUMELOTE,'[SEQ') + 4, 1));
      V_SEQLOTE  := SUBSTR(:NEW.NRLOTEESTQ, INSTR(V_STNUMELOTE,'[SEQ'), V_INAJUSTA);
   END IF;

   V_STORDELOTE := REPLACE(V_STORDELOTE, '[ANO]'  , TO_CHAR(V_DATA, 'YYYY'));
   V_STORDELOTE := REPLACE(V_STORDELOTE, '[ANO2]' , TO_CHAR(V_DATA, 'YY'));
   V_STORDELOTE := REPLACE(V_STORDELOTE, '[ANO4]' , TO_CHAR(V_DATA, 'YYYY'));

   V_STORDELOTE := REPLACE(V_STORDELOTE, '[MES]'  , TO_CHAR(V_DATA, 'MM'));
   V_STORDELOTE := REPLACE(V_STORDELOTE, '[DIA]'  , TO_CHAR(V_DATA, 'DD'));
   V_STORDELOTE := REPLACE(V_STORDELOTE, '[FIL]'  , :NEW.CDFILIAL);
   V_STORDELOTE := REPLACE(V_STORDELOTE, '[CDEXT]', V_CDPRODEXT);

   IF INSTR(V_STORDELOTE,'[SEQ]') > 0 THEN
      V_STORDELOTE := REPLACE(V_STORDELOTE, '[SEQ]'  , V_SEQLOTE);
   ELSIF INSTR(V_STORDELOTE,'[SEQ') > 0 THEN
      V_INAJUSTA   := TO_NUMBER(SUBSTR(V_STORDELOTE, INSTR(V_STORDELOTE,'[SEQ') + 4, 1));
      V_STORDELOTE := REPLACE(V_STORDELOTE, '[SEQ'||TO_CHAR(V_INAJUSTA)||']', V_SEQLOTE);
   END IF;

   IF NOT V_STORDELOTE IS NULL THEN
      :NEW.CDORDENALOTE := V_STORDELOTE;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_INSERT_LOTE','5.01.017'); END;
/

